package com.nsgk.agentcentersdk;

import com.nsgk.agentcentersdk.api.NSApiResult;
import com.nsgk.agentcentersdk.api.NSSDK;
import com.nsgk.agentcentersdk.api.NSSDKClient;
import com.nsgk.agentcentersdk.core.NSProtocol;
import com.nsgk.agentcentersdk.entity.NSContractionEntity;
import com.nsgk.agentcentersdk.utility.NSReflect;

public final class NSMain
{
    public static void main(String[] args) throws Exception
    {
        //Test();
        Test_reflect();
    }

    public static void Test_reflect() throws InstantiationException, IllegalAccessException
    {
        Class<?> NSContractionEntity_class = NSReflect.Class("com.nsgk.agentcentersdk.entity.NSContractionEntity");
        Class<?> NSSDK_class = NSReflect.Class("com.nsgk.agentcentersdk.api.NSSDK");
        Object client;
        Object entity;
        Object result;

        NSReflect.CallStatic_s(NSSDK_class, "InitClient", String.class, "http://localhost", short.class, (short) 8081, String.class, "test", String.class, "MFwwDQYJKoZIhvcNAQEBBQADSwAwSAJBAKoR8mX0rGKLqzcWmOzbfj64K8ZIgOdHnzkXSOVOZbFu/TJhZ7rFAN+eaGkl3C4buccQd/EjEsj9ir7ijT7h96MCAwEAAQ==");
        client = NSReflect.CallStatic(NSSDK_class, "InstanceClient");

        entity = NSContractionEntity_class.newInstance();
        NSReflect.Call(entity, "setBuildingTime", "2000-12-23");
        NSReflect.Call(entity, "setName", "测试合同");
        NSReflect.Call(entity, "setDeptId", 187L);
        NSReflect.Call(entity, "setBookId", 166L);
        NSReflect.Call(entity, "setOutId", 250L);

        result = NSReflect.Call_s(client, "Send", int.class, NSProtocol.NS_PROTOCOL_CONTRACTION, NSReflect.Class("com.nsgk.agentcentersdk.entity.NSEntityBase"), entity);
        System.err.println(result);
    }

    public static void Test()
    {
        NSSDKClient client;
        NSContractionEntity entity;
        NSApiResult result;

        NSSDK.InitClient("http://localhost", (short) 8081, "test", "MFwwDQYJKoZIhvcNAQEBBQADSwAwSAJBAKoR8mX0rGKLqzcWmOzbfj64K8ZIgOdHnzkXSOVOZbFu/TJhZ7rFAN+eaGkl3C4buccQd/EjEsj9ir7ijT7h96MCAwEAAQ==");
        client = NSSDK.InstanceClient();

        entity = new NSContractionEntity();
        entity.setBuildingTime("2000-12-23")
              .setName("测试合同")
              .setDeptId(187L)
              .setBookId(166L)
              .setOutId(999L)
        ;
        result = client.Send(NSProtocol.NS_PROTOCOL_CONTRACTION, entity);
        System.err.println(result);
    }
}
