package com.nsgk.agentcentersdk.entity;

import com.nsgk.agentcentersdk.utility.NSArr;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.Map;

// 基本实体
@Data
@Accessors(chain = true)
public abstract class NSEntityBase implements Serializable
{
    private static final long serialVersionUID = 1L;

    /** 账套ID */
    protected Long bookId;

    /** 部门id */
    protected Long deptId;

    /** 外部ID */
    protected Long outId;

    protected Map<String, Object> parms;

    protected Map<String, Object> PARMS()
    {
        if(null == parms)
            parms = new LinkedHashMap<>();
        return parms;
    }

    @SuppressWarnings("unchecked")
    public <T extends NSEntityBase> T Parm(String name, Object val)
    {
        PARMS().put(name, val);
        return (T)this;
    }

    @SuppressWarnings("unchecked")
    public <T extends NSEntityBase> T DelParm(String...name)
    {
        if(null != parms && NSArr.IsNotEmpty(name))
        {
            NSArr.Stream(name).forEach(parms::remove);
        }
        return (T)this;
    }

    public boolean HasParm(String name)
    {
        if(null == parms)
            return false;
        return parms.containsKey(name);
    }

    @SuppressWarnings("unchecked")
    public <T> T ParmT(String name, T...val)
    {
        T def = NSArr.DefParm(val);
        if(null == parms)
            return def;
        return (T)parms.getOrDefault(name, def);
    }
}
