package com.nsgk.agentcentersdk.network;

import com.nsgk.agentcentersdk.utility.NSArr;
import com.nsgk.agentcentersdk.utility.NSStr;
import lombok.Data;
import lombok.experimental.Accessors;

import java.util.LinkedHashMap;
import java.util.Map;

// Http传输
@Data
@Accessors(chain = true)
public class NSNetworkTransport
{
    private String              url;
    private final Map<String, String> headers = new LinkedHashMap<>();
    private final Map<String, Object> query = new LinkedHashMap<>();
    private String data;

    public NSNetworkTransport() {}

    public NSNetworkTransport(String url)
    {
        this.url = url;
    }

    public NSNetworkTransport ClearHeaders()
    {
        headers.clear();
        return this;
    }

    public NSNetworkTransport AddHeader(String name, Object value)
    {
        headers.put(name, NSStr.ToString(value));
        return this;
    }

    public String Header(String name, String...value)
    {
        return headers.getOrDefault(name, NSArr.DefParm(value));
    }

    public NSNetworkTransport ClearQueries()
    {
        query.clear();
        return this;
    }

    public NSNetworkTransport AddQuery(String name, Object value)
    {
        query.put(name, value);
        return this;
    }

    public Object Query(String name, Object...value)
    {
        return query.getOrDefault(name, NSArr.DefParm(value));
    }
}
