package com.nsgk.agentcentersdk.utility;

import cn.hutool.core.codec.Base64;
import cn.hutool.core.util.StrUtil;
import cn.hutool.crypto.SecureUtil;
import cn.hutool.crypto.asymmetric.KeyType;
import cn.hutool.crypto.asymmetric.RSA;

import java.nio.charset.StandardCharsets;

// 加密工具
public final class NSCrypto
{
    // RSA公钥加密(客户端) raw -> base64
    public static String RSAEncrypt(String rawData, String publicKey_base64)
    {
        RSA rsa;

        if(NSStr.IsEmpty(rawData) || NSStr.IsEmpty(publicKey_base64))
            return "";
        rsa = SecureUtil.rsa(null, publicKey_base64);
        return rsa.encryptBase64(rawData, KeyType.PublicKey);
    }

    // RSA私钥解密(服务端) base64 -> raw
    public static String RSADecrypt(String encryptBase64Data, String privateKey_base64)
    {
        RSA rsa;

        if(NSStr.IsEmpty(encryptBase64Data) || NSStr.IsEmpty(privateKey_base64))
            return "";
        rsa = SecureUtil.rsa(privateKey_base64, null);
        return StrUtil.str(rsa.decrypt(Base64.decode(encryptBase64Data), KeyType.PrivateKey), StandardCharsets.UTF_8);
    }

    private NSCrypto() {}
}
