package com.ruoyi.web.controller.agentcenter;

import com.nsgk.agentcentersdk.api.NSApiResult;
import com.nsgk.agentcentersdk.api.NSSDK;
import com.nsgk.agentcentersdk.api.NSSDKServer;
import com.nsgk.agentcentersdk.core.NSProtocol;
import com.nsgk.agentcentersdk.core.NSReportObject;
import com.nsgk.agentcentersdk.entity.NSContractionEntity;
import com.nsgk.agentcentersdk.err.NSErrGlobal;
import com.nsgk.agentcentersdk.err.NSErrno;
import com.nsgk.agentcentersdk.err.NSException;
import com.ruoyi.agentcenter.object.ContractionMessage;
import com.ruoyi.agentcenter.object.Message;
import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.utils.EventBusEngine;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

/**
 * 上报接口Controller
 * 
 * @author zhao
 */
@RestController
@RequestMapping("/agentcenter/api")
public class AgentCenterController extends BaseController
{
    @PostMapping("/test")
    public NSApiResult test(HttpServletRequest request)
    {
        NSSDKServer server;
        NSReportObject<NSContractionEntity> recv;

        NSSDK.InitServer(RuoYiConfig.Secret.privateKey);
        server = NSSDK.InstanceServer();
        recv = server.Recv(request, NSContractionEntity.class);

        return server.Resp(0, "测试成功", recv.getDataStr());
    }

    @PostMapping("/report")
    public NSApiResult report(HttpServletRequest request)
    {
        NSSDKServer server;
        NSReportObject<NSContractionEntity> recv;

        NSSDK.InitServer(RuoYiConfig.Secret.privateKey);
        try
        {
            server = NSSDK.InstanceServer();
            recv = server.Recv(request, NSContractionEntity.class);

            EventBusEngine.Post(convMsg(recv));

            return NSSDKServer.Success("上报成功");
        }
        catch(NSException e)
        {
            return NSSDKServer.Fail(e.getErrno(), e.getMessage());
        }
    }

    private Message<?> convMsg(NSReportObject<?> reportObject)
    {
        Message<?> msg;
        int protocol;

        protocol = reportObject.getProtocol();
        switch(reportObject.getProtocol())
        {
            case NSProtocol.NS_PROTOCOL_CONTRACTION:
                msg = new ContractionMessage(protocol, reportObject.getIdentifier(), reportObject.getTimestamp(), (NSContractionEntity)reportObject.getData());
                break;
            default:
                NSErrGlobal.Err(NSErrno.ERRNO_SYS_INVALID_PROTOCOL);
                throw new RuntimeException(String.format("未知的协议类型: 0x%x", protocol));
        }
        return msg;
    }
}
