package com.ruoyi.agentcenter.domain;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.experimental.Accessors;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 任务清单对象 t_agent_task
 * 
 * @author zhao
 * @date 2023-05-06
 */
@Data
@Accessors(chain = true)
public class TAgentTask extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** id */
    private Long id;

    /** 所属中心 字典 agent_center */
    @Excel(name = "所属中心", dictType = "agent_center")
    private String agentCenter;

    /** 县代码 */
    @Excel(name = "县代码")
    private String countyCode;

    /** 县名称 */
    @Excel(name = "县名称")
    private String countyName;

    /** 镇代码 */
    @Excel(name = "镇代码")
    private String townCode;

    /** 镇名称 */
    @Excel(name = "镇名称")
    private String townName;

    /** 村代码 */
    @Excel(name = "村代码")
    private String orgCode;

    /** 村名称 */
    @Excel(name = "村名称")
    private String orgName;

    /** 账套数 */
    @Excel(name = "账套数")
    private Integer bookCount;

    /** 凭证数 */
    @Excel(name = "凭证数")
    private Integer voucherCount;

    /** 合同数 */
    @Excel(name = "合同数")
    private Integer contractionCount;

    /** 资产数 */
    @Excel(name = "资产数")
    private Integer assetCount;

    /** 任务总数 */
    @Excel(name = "任务总数")
    private Integer allCount;

    /** 任务年度 */
    @Excel(name = "任务年度")
    private String orderYear;

    /** 任务月份 */
    @Excel(name = "任务月份")
    private String orderMonth;

    /** 任务状态 字典 agent_status  (任务人全部完成后交任务的动作) */
    @Excel(name = "任务状态", dictType = "agent_status")
    private String agentStatus;

    /** 分配主管(用user_name） */
    @Excel(name = "分配主管")
    private String distributionChief;

    /** 分配时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "分配时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date distributionDate;

    /** 任务截止日期 */
    @Excel(name = "任务截止日期")
    private String endAt;

    /** 记账会计(即被分配人，用user_name） */
    @Excel(name = "记账会计")
    private String handleAccount;

    /** 记账完成时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "记账完成时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date handleDate;

    /** 审核会计(用user_name） */
    @Excel(name = "审核会计(用user_name）")
    private String auditAccount;

    /** 审核时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "审核时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date auditDate;

    /** 任务评分（分配主管来评价） */
    @Excel(name = "任务评分")
    private BigDecimal taskScore;

    /** 任务评价 */
    @Excel(name = "任务评价")
    private String taskAppraise;

}
