package com.ruoyi.agentcenter.mapper;

import java.util.List;
import com.ruoyi.agentcenter.domain.TAgentTask;

/**
 * 任务清单Mapper接口
 * 
 * @author zhao
 * @date 2023-05-06
 */
public interface TAgentTaskMapper 
{
    /**
     * 查询任务清单
     * 
     * @param id 任务清单主键
     * @return 任务清单
     */
    public TAgentTask selectTAgentTaskById(Long id);

    /**
     * 查询任务清单列表
     * 
     * @param tAgentTask 任务清单
     * @return 任务清单集合
     */
    public List<TAgentTask> selectTAgentTaskList(TAgentTask tAgentTask);

    /**
     * 新增任务清单
     * 
     * @param tAgentTask 任务清单
     * @return 结果
     */
    public int insertTAgentTask(TAgentTask tAgentTask);

    /**
     * 批量新增任务清单
     *
     * @param list 任务清单
     * @return 结果
     */
    public int insertTAgentTaskBatch(List<TAgentTask> list);

    /**
     * 批量修改 任务清单
     *
     * @param list 任务清单
     * @return 结果
     */
    public int updateTAgentTaskBatch(List<TAgentTask> list);

    /**
     * 修改任务清单
     * 
     * @param tAgentTask 任务清单
     * @return 结果
     */
    public int updateTAgentTask(TAgentTask tAgentTask);

    /**
     * 删除任务清单
     * 
     * @param id 任务清单主键
     * @return 结果
     */
    public int deleteTAgentTaskById(Long id);

    /**
     * 批量删除任务清单
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTAgentTaskByIds(Long[] ids);

    // Harm
    /**
     * 条件单条查询任务清单
     *
     * @param tAgentTask 任务清单
     * @return 任务清单条目
     */
    public TAgentTask selectTAgentTask(TAgentTask tAgentTask);

    /**
     * 条件查询任务清单数量
     *
     * @param tAgentTask 任务清单
     * @return 任务清单数量
     */
    public Long selectTAgentTaskCount(TAgentTask tAgentTask);

    /**
     * 条件查询任务清单是否存在
     *
     * @param tAgentTask 任务清单
     * @return 任务清单是否存在
     */
    public int selectTAgentTaskExists(TAgentTask tAgentTask);
}
