package com.ruoyi.agentcenter.object;

import com.nsgk.agentcentersdk.core.NSProtocol;
import lombok.Data;
import lombok.experimental.Accessors;

@Data
@Accessors(chain = true)
public abstract class Message<T>
{
    private final int protocol; // 协议
    private final String identifier; // 识别ID
    private final Long timestamp; // 客户端时间戳
    private final T data;

    public Message()
    {
        this.protocol = NSProtocol.NS_PROTOCOL_INVALID;
        this.identifier = "";
        this.timestamp = 0L;
        this.data = null;
    }

    public Message(int protocol, String identifier, Long timestamp, T data)
    {
        this.protocol = protocol;
        this.identifier = identifier;
        this.timestamp = timestamp;
        this.data = data;
    }
}
